// 2003/03/19 FileWatcher.cs
// Copyright (C) Ortana<ortaclient@hotmail.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Windows.Forms;
using System.IO;
using System.Collections;

using NTF.HXD.DOC;

namespace NTF.DOC
{
	/// <summary>
	/// t@C̕ωʒm܂B
	/// </summary>
	public class FileWatcher
	{
		string path;
		public FileWatcher(string path)
		{
			this.path = Path.GetFullPath(path);
			InitializeWathcer();
		}

		public delegate void ChangedEventHandler();
		/// <summary>
		/// ǉt@CXVꂽƂm点Cxg
		/// </summary>
		public event ChangedEventHandler Changed;

		ArrayList watchFileList = new ArrayList();
		string[] watchFiles = null;

		/// <summary>
		/// AvP[Ṽt@CǉAĎ邽߂ɒǉB
		/// </summary>
		/// <param name="path">Ďt@C̃pX
		/// (AvP[VtH_̃pX)
		/// </param>
		public void AddWatchFile(string path)
		{
			watchFileList.Add(Path.GetFullPath(path));
			watchFiles = Support.ListToStrings( watchFileList );
		}

		private void InitializeWathcer()
		{
			OperatingSystem os = System.Environment.OSVersion;
			if( os.Platform == PlatformID.Win32NT )
			{
				try
				{
					FileSystemWatcher watcher = new FileSystemWatcher();
					watcher.Path = this.path;

					watcher.NotifyFilter = NotifyFilters.LastWrite ;
				
					watcher.Changed += new FileSystemEventHandler(OnChanged);

					watcher.EnableRaisingEvents = true;
				}
				catch(System.Exception error)
				{
					System.Diagnostics.Debug.WriteLine(error);
				}
			}
		}

		private void OnChanged(object source, FileSystemEventArgs e)
		{
			if( watchFiles == null )
			{
				return;
			}

			if( Support.SearchText( this.watchFiles , e.FullPath ) < 0 )
			{
				return;
			}

			if( Changed == null )
			{
				return;
			}

			foreach(ChangedEventHandler changed in Changed.GetInvocationList())
			{
				try
				{
					changed();
				}
				catch(System.Exception error)
				{
					System.Diagnostics.Debug.WriteLine(error);
				}
			}
		
		}

	}
}
